package com.jyk.mybatis.dynamic;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.ibatis.session.SqlSession;

import com.jyk.mybatis.util.MyBatisUtil;

public class StudentDao {
	/*
	 * ̬ѯ
	 */
	public List<Student> findAll(String id,String name,String age,String sex)
	{
		SqlSession sqlSession = null;
		try{
			sqlSession = MyBatisUtil.getSqlSession();
			
			Map<String,Object> stuMap = new HashMap<String,Object>();
			stuMap.put("id", id);
			stuMap.put("name", name);
			stuMap.put("age", age);
			stuMap.put("sex", sex);
			
			return sqlSession.selectList(Student.class.getName()+".findAll", stuMap);
		}catch(Exception e){
			e.printStackTrace();
			throw e;
		}finally{
			MyBatisUtil.closeSqlSession();
		}
	}
	
	/*
	 * ̬
	 */
	public List<Student> update(String id,String name,String age,String sex)
	{
		SqlSession sqlSession = null;
		try{
			sqlSession = MyBatisUtil.getSqlSession();
			
			Map<String,Object> updateMap = new HashMap<String,Object>();
			updateMap.put("id", id);
			updateMap.put("name", name);
			updateMap.put("age", age);
			updateMap.put("sex", sex);
			
			sqlSession.update(Student.class.getName()+".update",updateMap);
			
			sqlSession.commit();
			return null;
		}catch(Exception e){
			e.printStackTrace();
			sqlSession.rollback();
			throw e;
		}finally{
			MyBatisUtil.closeSqlSession();
		}
	}
	
	/*
	 * ̬ɾ
	 */
	public void dynamicDelete(String... ids)
	{
		SqlSession sqlSession = null;
		try{
			sqlSession = MyBatisUtil.getSqlSession();
			
			sqlSession.delete(Student.class.getName()+".dynamicDelete",ids);
			
			sqlSession.commit();
		}catch(Exception e){
			e.printStackTrace();
			throw e;
		}finally{
			MyBatisUtil.closeSqlSession();
		}
	}
	
	/*
	 * ̬Listɾ
	 */
	public void dynamicDeleteList(List<String> ids)
	{
		SqlSession sqlSession = null;
		try{
			sqlSession = MyBatisUtil.getSqlSession();
			
			sqlSession.delete(Student.class.getName()+".dynamicDeleteList",ids);
			
			sqlSession.commit();
		}catch(Exception e){
			e.printStackTrace();
			throw e;
		}finally{
			MyBatisUtil.closeSqlSession();
		}
	}
	
	/*
	 * ̬
	 */
	public void dynamicInsert(Student stu)
	{
		SqlSession sqlSession = null;
		try{
			sqlSession = MyBatisUtil.getSqlSession();
			
			sqlSession.insert(Student.class.getName()+".dynamicInsert", stu);
			
			sqlSession.commit();
		}catch(Exception e){
			e.printStackTrace();
			throw e;
		}finally{
			MyBatisUtil.closeSqlSession();
		}
	}
	
	public static void main(String[] args) {
		StudentDao sd = new StudentDao();
//		List<Student> stuList = sd.findAll(null, null, null, null);
//		for(Student stu:stuList)
//		{
//			System.out.println(stu.getId()+"|"+stu.getName()+"|"+stu.getAge()+"|"+stu.getSex());
//		}
		//sd.update("2","",null,"dog");
		//sd.dynamicDelete("1","2");
		/*List<String> ids = new ArrayList<>();
		ids.add("3");
		ids.add("4");
		ids.add("5");
		sd.dynamicDeleteList(ids);*/
		sd.dynamicInsert(new Student("13", "", "45", "Ů"));
	}
}
