package com.jyk.mybatis.util;

import java.io.IOException;
import java.io.Reader;
import java.sql.Connection;

import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;

/*
 * MyBatis
 */
public class MyBatisUtil {

	private static ThreadLocal<SqlSession> threadLocal = new
			ThreadLocal<SqlSession>();
	private static SqlSessionFactory sqlSessionFactory;
	
	//̬srcĿ¼µmybatisļ
	static{
		try {
			Reader reader = Resources.getResourceAsReader("mybatis.xml");
			sqlSessionFactory = new SqlSessionFactoryBuilder().build(reader);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	/*
	 * ֹͨnew
	 */
	private MyBatisUtil(){}
	
	/*
	 * ȡsqlsession
	 */
	public static SqlSession getSqlSession()
	{
		//ӵǰ߳лȡsqlSession
		SqlSession sqlSession = threadLocal.get();
		
		//жSqlSessionǷΪ
		if(sqlSession==null)
		{
			//SqlSessionFactoryǿյ£ȡSqlSession
			sqlSession = sqlSessionFactory.openSession();
			//SqlSession뵱ǰ̰߳һ
			threadLocal.set(sqlSession);
		}
		
		return sqlSession;
	}
	
	/*
	 * رsqlsession뵱ǰ̷ֿ߳
	 */
	public static void closeSqlSession()
	{
		//ӵǰ߳лȡSqlSession
		SqlSession sqlSession = threadLocal.get();
		
		if(sqlSession != null)
		{
			//رSqlSession
			sqlSession.close();
			//ֿǰ߳SqlSessionĹϵĿǾ
			threadLocal.remove();
		}		
	}
	
	/*
	 * Է
	 */
	public static void main(String[] args) {
		Connection conn = MyBatisUtil.getSqlSession().getConnection();
		if(conn==null)
		{
			System.out.println("Ϊ");
		}
		else
		{
			System.out.println("ӲΪ");
		}
	}
}
